/*
**
**	Event header. FirEdge / Ethereal.
**
*/


// The work was stopped on 06/11/2001 to make effects for the demo "conceptual"


#ifndef _EVENT_HPP_
#define _EVENT_HPP_


#include "demoengine.hpp"


#define EVENT_FX 1
#define EVENT_PUSH 2


class Event
{
public:

	short EventID;
	unsigned long time;
	int slot;
	Demo* env;

	virtual void Execute() = 0;

	/*
	**	The following was done to use an external timeline editor (click&demo).
	**	Not done, because of a lack of time before VIP3 ... :-(
	*/

	virtual bool SaveToFile( ofstream& output ) = 0;
	virtual bool ReadFromFile( Demo* environement, ifstream& input ) = 0;
};


/*
**	The derivated events.
*/


class EventFX : public Event
{
public:

	int FXid;
	unsigned long endfx;

	EventFX(Demo* environement, unsigned long t = 0, unsigned long end = 0, int s = 0, int id = 0 );

	void Execute();
	bool SaveToFile( ofstream& output );
	bool ReadFromFile(Demo *environement, ifstream& input );

	~EventFX();
};



class EventPush : public Event
{
public:

	unsigned long pushtype;
	float pushvalue;

	EventPush(Demo* environement, unsigned long t = 0, int slot = 7, unsigned long type = 0, float value = 1.0f );

	void Execute();

	bool SaveToFile( ofstream& output );
	bool ReadFromFile( Demo* environement, ifstream& input  );

};



#endif